<?php
include ("lec27ex01lib.php");

if (! isset ( $_REQUEST ['cid'] )) {
	die ( "Wow, that is not right." );
}
$cid = $_REQUEST ['cid'];
if (isset ( $_REQUEST ['val'] )) {
	/* There is a weakness and vulnerability that arises in this page
	 * when one considers how the value is used.  Experiment below
	 * with the two different forms of sanitizing input. Then think about
	 * what might be a work around.  After you think about it, then
	 * consder a complete re-write using a prepated statement!
	 */
	// $val = filter_var($_REQUEST ['val'], FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);	
	$val = strip_tags ( $_REQUEST ['val'] );
	// $val = str_replace("--","-",$val); // bit of a hack, but fixes immediate problem
	// echo "<p> Here it is $val </p>";
}
try {
	$dbh = new PDO ( "sqlite:./lec27ex01.db" );
} catch ( PDOException $e ) {
	echo $e->getMessage ();
}
$flds = explode ( "_", $cid );

$row = intval ( $flds [1] );
$fld = $flds [2];
$tme = time ();
/*
 * There is a nice example of a vulnerability using this code.
 * If a user enters exactly the following text into a field
 * cows" --
 * Then the qualifier specifying the specific dog is ignored
 * and all dogs have this field set.
 */
$dbh->exec ( "UPDATE dogs SET $fld=\"$val\" WHERE dog_id = $row" );
$dbh->exec ( "UPDATE dogs SET uptime=\"$tme\" WHERE dog_id = $row" );
echo "Last database Update: " . lastUpdatedHTML ();
?>